Index: code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc	(revision 2357)
+++ code/branches/objecthierarchy2/src/orxonox/tools/Shader.cc	(revision 2358)
@@ -63,5 +63,4 @@
         this->compositor_ = "";
         this->oldcompositor_ = "";
-//        this->parameter_ = 0;
 
         if (this->bLoadCompositor_ && Ogre::Root::getSingletonPtr())
@@ -107,82 +106,4 @@
             this->updateVisibility();
         }
-
-/*
-        COUT(0) << std::endl << "GpuPrograms:" << std::endl;
-        Ogre::GpuProgramManager::ResourceMapIterator iterator = Ogre::GpuProgramManager::getSingleton().getResourceIterator();
-        while (iterator.hasMoreElements())
-            COUT(0) << iterator.getNext()->getName() << std::endl;
-*/
-/*
-        Ogre::Resource* resource = Ogre::GpuProgramManager::getSingleton().getByName("Radial_Blur_ps_cg").get();
-        if (resource)
-        {
-            COUT(0) << std::endl << "Resource parameters:" << std::endl;
-            const Ogre::ParameterList& resourceparameters = resource->getParameters();
-            for (size_t i = 0; i < resourceparameters.size(); ++i)
-                COUT(0) << resourceparameters[i].name << std::endl;
-
-            COUT(0) << std::endl << "GpuProgram:" << std::endl;
-            Ogre::GpuProgram* gpuprogram = (Ogre::GpuProgram*)resource;
-            COUT(0) << gpuprogram << std::endl;
-
-            COUT(0) << std::endl << "GpuProgram default parameters:" << std::endl;
-            Ogre::GpuProgramParameters* defaultparams = gpuprogram->getDefaultParameters().get();
-            COUT(0) << defaultparams << std::endl;
-            if (defaultparams)
-            {
-//                defaultparams->setNamedConstant("sampleStrength", 2.0f);
-
-                const Ogre::GpuConstantDefinitionMap& constantdefinitions = defaultparams->getConstantDefinitions().map;
-                for (Ogre::GpuConstantDefinitionMap::const_iterator it = constantdefinitions.begin(); it != constantdefinitions.end(); ++it)
-                    COUT(0) << it->first << " / " << it->second.physicalIndex << " / " << it->second.isFloat() << " / " << (float)((it->second.isFloat()) ? (*defaultparams->getFloatPointer(it->second.physicalIndex)) : (*defaultparams->getIntPointer(it->second.physicalIndex))) << std::endl;
-
-                Ogre::GpuConstantDefinitionMap::const_iterator it = constantdefinitions.find("sampleStrength");
-                if (it != constantdefinitions.end())
-                {
-                    if (it->second.isFloat())
-                    {
-                        COUT(0) << (defaultparams->getFloatPointer(it->second.physicalIndex)) << std::endl;
-                        COUT(0) << (*defaultparams->getFloatPointer(it->second.physicalIndex)) << std::endl;
-                        (*defaultparams->getFloatPointer(it->second.physicalIndex)) = 10.0f;
-                    }
-                    else
-                    {
-                        COUT(0) << (defaultparams->getIntPointer(it->second.physicalIndex)) << std::endl;
-                        COUT(0) << (*defaultparams->getIntPointer(it->second.physicalIndex)) << std::endl;
-                        (*defaultparams->getIntPointer(it->second.physicalIndex)) = 10;
-                    }
-                    // doesn't work because it's "manually loaded":
-                    //
-                    // Ogre: Creating viewport on target 'rtt/166241248', rendering from camera '140', relative
-                    // dimensions L: 0.00 T: 0.00 W: 1.00 H: 1.00 ZOrder: 0
-                    //
-                    // Ogre: WARNING: Texture instance 'CompositorInstanceTexture0' was defined as manually
-                    // loaded, but no manual loader was provided. This Resource will be lost if it has to be
-                    // reloaded.
-                    //
-//                    gpuprogram->reload();
-                }
-
-            }
-
-            COUT(0) << "end" << std::endl;
-        }
-*/
-/*
-        if (this->parameter_ && this->bViewportInitialized_)
-        {
-            (*this->parameter_) += dt;
-
-            if (this->compositorInstance_ && this->isVisible())
-            {
-                this->compositorInstance_->setEnabled(false);
-                this->compositorInstance_->setEnabled(true);
-            }
-        }
-*/
-
-//        this->setParameter("Ogre/Compositor/Radial_Blur", 0, 0, "sampleStrength", Shader::getParameter("Ogre/Compositor/Radial_Blur", 0, 0, "sampleStrength") + dt / 3.0f);
-//        this->setParameter("Ogre/Compositor/Tiling", 0, 0, "NumTiles", Shader::getParameter("Ogre/Compositor/Tiling", 0, 0, "NumTiles") + dt);
     }
 
@@ -203,135 +124,4 @@
                 if (!this->compositorInstance_)
                     COUT(2) << "Warning: Couldn't load compositor with name \"" << this->compositor_ << "\"." << std::endl;
-                else
-                {
-/*
-                    COUT(0) << std::endl << "GpuPrograms:" << std::endl;
-                    Ogre::GpuProgramManager::ResourceMapIterator gpuprogramiterator = Ogre::GpuProgramManager::getSingleton().getResourceIterator();
-                    while (gpuprogramiterator.hasMoreElements())
-                        COUT(0) << gpuprogramiterator.getNext()->getName() << std::endl;
-*/
-/*
-                    COUT(0) << std::endl << "compositor:" << std::endl;
-                    Ogre::Compositor* compositor = this->compositorInstance_->getCompositor();
-                    COUT(0) << compositor << std::endl;
-
-                    if (!compositor)
-                        return;
-
-                    COUT(0) << std::endl << "compositor parameters:" << std::endl;
-                    const Ogre::ParameterList& compparameters = compositor->getParameters();
-                    for (size_t i = 0; i < compparameters.size(); ++i)
-                        COUT(0) << compparameters[i].name << std::endl;
-
-                    COUT(0) << std::endl << "compositor technique:" << std::endl;
-                    Ogre::CompositionTechnique* comptechnique = compositor->getSupportedTechnique(0);
-                    COUT(0) << comptechnique << std::endl;
-
-                    if (!comptechnique)
-                        return;
-
-                    COUT(0) << std::endl << "compositor target pass:" << std::endl;
-                    Ogre::CompositionTargetPass* comptargetpass = comptechnique->getTargetPass(0);
-                    COUT(0) << comptargetpass << std::endl;
-
-                    if (!comptargetpass)
-                        return;
-
-                    COUT(0) << std::endl << "compositor pass:" << std::endl;
-                    Ogre::CompositionPass* comppass = comptargetpass->getPass(0);
-                    COUT(0) << comppass << std::endl;
-
-                    if (!comppass)
-                        return;
-
-                    COUT(0) << std::endl << "material:" << std::endl;
-                    Ogre::Material* material = comppass->getMaterial().get();
-                    COUT(0) << material << std::endl;
-*/
-/*
-                    COUT(0) << std::endl << "Materials:" << std::endl;
-                    Ogre::MaterialManager::ResourceMapIterator iterator = Ogre::MaterialManager::getSingleton().getResourceIterator();
-                    Ogre::Material* material = 0;
-                    while (iterator.hasMoreElements())
-                    {
-                        Ogre::Resource* resource = iterator.getNext().get();
-                        COUT(0) << resource->getName() << std::endl;
-                        if (resource->getName() == "Ogre/Compositor/Radial_Blur")
-                        {
-                            material = (Ogre::Material*)resource;
-                            COUT(0) << "found it!" << std::endl;
-                        }
-                    }
-
-                    if (!material)
-                        return;
-
-                    COUT(0) << std::endl << "material parameters:" << std::endl;
-                    const Ogre::ParameterList& materialparameters = material->getParameters();
-                    for (size_t i = 0; i < materialparameters.size(); ++i)
-                        COUT(0) << materialparameters[i].name << std::endl;
-
-                    COUT(0) << std::endl << "technique:" << std::endl;
-                    Ogre::Technique* technique = material->getTechnique(0);
-                    COUT(0) << technique << std::endl;
-
-                    if (!technique)
-                        return;
-
-                    COUT(0) << std::endl << "pass:" << std::endl;
-                    Ogre::Pass* pass = technique->getPass(0);
-                    COUT(0) << pass << std::endl;
-
-                    if (!pass)
-                        return;
-
-                    COUT(0) << std::endl << "fragment program parameters:" << std::endl;
-                    Ogre::GpuProgramParameters* fragmentparams = pass->getFragmentProgramParameters().get();
-                    COUT(0) << fragmentparams << std::endl;
-                    if (fragmentparams)
-                    {
-                        const Ogre::GpuConstantDefinitionMap& constantdefinitions = fragmentparams->getConstantDefinitions().map;
-                        for (Ogre::GpuConstantDefinitionMap::const_iterator it = constantdefinitions.begin(); it != constantdefinitions.end(); ++it)
-                            COUT(0) << it->first << " / " << it->second.physicalIndex << " / " << it->second.isFloat() << " / " << (float)((it->second.isFloat()) ? (*fragmentparams->getFloatPointer(it->second.physicalIndex)) : (*fragmentparams->getIntPointer(it->second.physicalIndex))) << std::endl;
-
-                        Ogre::GpuConstantDefinitionMap::const_iterator it = constantdefinitions.find("sampleStrength");
-
-                        if (it != constantdefinitions.end())
-                        {
-                            if (it->second.isFloat())
-                            {
-                                COUT(0) << (fragmentparams->getFloatPointer(it->second.physicalIndex)) << std::endl;
-                                COUT(0) << (*fragmentparams->getFloatPointer(it->second.physicalIndex)) << std::endl;
-                                (*fragmentparams->getFloatPointer(it->second.physicalIndex)) = 0.0f;
-                                this->parameter_ = fragmentparams->getFloatPointer(it->second.physicalIndex);
-                            }
-                            else
-                            {
-                                COUT(0) << (fragmentparams->getIntPointer(it->second.physicalIndex)) << std::endl;
-                                COUT(0) << (*fragmentparams->getIntPointer(it->second.physicalIndex)) << std::endl;
-                                (*fragmentparams->getIntPointer(it->second.physicalIndex)) = 0;
-                            }
-                        }
-                    }
-
-                    COUT(0) << std::endl << "fragment program:" << std::endl;
-                    COUT(0) << (&pass->getFragmentProgram()) << std::endl;
-
-                    COUT(0) << std::endl << "fragment program name:" << std::endl;
-                    COUT(0) << pass->getFragmentProgramName() << std::endl;
-
-                    COUT(0) << std::endl << "GpuProgram default parameters:" << std::endl;
-                    Ogre::GpuProgramParameters* defaultparams = pass->getFragmentProgram().get()->getDefaultParameters().get();
-                    COUT(0) << defaultparams << std::endl;
-                    if (defaultparams)
-                    {
-                        const Ogre::GpuConstantDefinitionMap& constantdefinitions = defaultparams->getConstantDefinitions().map;
-                        for (Ogre::GpuConstantDefinitionMap::const_iterator it = constantdefinitions.begin(); it != constantdefinitions.end(); ++it)
-                            COUT(0) << it->first << " / " << it->second.physicalIndex << " / " << it->second.isFloat() << " / " << (float)((it->second.isFloat()) ? (*defaultparams->getFloatPointer(it->second.physicalIndex)) : (*defaultparams->getIntPointer(it->second.physicalIndex))) << std::endl;
-                    }
-
-                    COUT(0) << std::endl << "end" << std::endl;
-*/
-                }
                 Ogre::CompositorManager::getSingleton().setCompositorEnabled(viewport, this->compositor_, this->bViewportInitialized_ && this->isVisible());
             }
Index: code/branches/objecthierarchy2/src/orxonox/tools/Shader.h
===================================================================
--- code/branches/objecthierarchy2/src/orxonox/tools/Shader.h	(revision 2357)
+++ code/branches/objecthierarchy2/src/orxonox/tools/Shader.h	(revision 2358)
@@ -99,6 +99,5 @@
             std::string compositor_;
             std::string oldcompositor_;
-//            float* parameter_;
-//            std::map<std::string, std::vector<std::vector<std::map<std::string, std::pair<bool, void*> > > > > parameters_;
+
             static MaterialMap parameters_s;
             static bool bLoadedCgPlugin_s;